CREATE OR REPLACE Function UYE.SF_REP_GZTOPLAM
( pTahakkukSiraNo in tahakkuk.tahakkuksirano%type default null
) RETURN NUMBER

/*AUTHOR    :   GKTAN ELGIN
PURPOSE     :   Tahakkuka ait gecikme zammi toplam geri dner
                bu fonksiyon aidat raporlarinin
                hemen hemen tmnde kullanilmaktadir.
UPDATE      :   04.05.2015

*/

  AUTHID CURRENT_USER AS
  tTutar number(20,2);
  tTemp number;
  tToplam number(20,2) default null;
  tTahakkukSiraNo number;
  tNextTahakkukSiraNo number;

  Degiskenler varchar2(255);

  exgenel exception;

  cursor gz_cursor is
            SELECT A.TUTAR
            FROM UYE.TAHAKKUK A, UYE.MAKBUZDETAY MD
              WHERE A.USTTAHAKKUKSIRANO = pTahakkukSiraNo AND
                    A.TAHAKKUKSIRANO = MD.TAHAKKUKSIRANO (+) AND
-- GE: 04.05.2015 Yaplandrma iim -------------------------------------------                    
                    (A.YAPILANDIRMA  <> '1' OR A.YAPILANDIRMA IS NULL) AND
-------------------------------------------------------------------------------                    
--                    MD.MAKBUZDETAYSIRANO IS NULL AND
                    A.TAHAKKUKTIPI = 'C' AND
                    A.AF  <> '1' ;
begin

    if pTahakkukSiraNo is null then return null; end if;
    tToplam := 0;
    open gz_cursor;
    loop
        begin
            fetch gz_cursor into tTutar;
            exit when gz_cursor%NOTFOUND;
            exception
                  WHEN OTHERS THEN
            exit;
        end;
        tToplam := tTutar;
    end loop;

    If tToplam = 0 Then
           tToplam := NULL;
    end If;

return tToplam ;

exception
     when others then
       return null;
end;
/

CREATE OR REPLACE Function UYE.SF_REP_GZTOPLAMTAHSILAT
( pTahakkukSiraNo in tahakkuk.tahakkuksirano%type default null
) RETURN NUMBER


/*AUTHOR    :   GKTAN ELGIN
PURPOSE     :   Tahakkuka ait gecikme zammi toplam tahsilatini geri dner
                bu fonksiyon aidat raporlarinin
                hemen hemen tmnde kullanilmaktadir.
UPDATE      :   04.05.2015

*/

  AUTHID CURRENT_USER AS
  tTutar NUMBER(20,2);
  tTemp number;
  tToplam NUMBER(20,2) default null;
  tTahakkukSiraNo number;
  tNextTahakkukSiraNo number;
  terrmsg varchar2(2000);

  Degiskenler varchar2(255);

  exgenel exception;

  cursor gz_cursor is
            SELECT MD.TUTAR , A.TAHAKKUKSIRANO
	        FROM UYE.TAHAKKUK A, UYE.MAKBUZDETAY MD
			  WHERE A.USTTAHAKKUKSIRANO = tNextTahakkukSiraNo AND
			        A.TAHAKKUKSIRANO = MD.TAHAKKUKSIRANO (+) AND
-- GE: 04.05.2015 Yaplandrma iim -------------------------------------------                    
                    (A.YAPILANDIRMA  <> '1' OR A.YAPILANDIRMA IS NULL) AND
-------------------------------------------------------------------------------                    
    		        (MD.MAKBUZDETAYSIRANO IS NOT NULL OR A.TAHSILEDILDI = '1') AND
			        A.TAHAKKUKTIPI = 'C' AND
			        A.AF  <> '1' ;
begin

    if pTahakkukSiraNo is null then return null; end if;
    tNextTahakkukSiraNo := pTahakkukSiraNo;

    tToplam := 0;
    loop
    open gz_cursor;
        begin
            fetch gz_cursor into tTutar , tNextTahakkukSiraNo;
                exit when gz_cursor%NOTFOUND;
            terrmsg := SQLERRM;
            if tNextTahakkukSiraNo is null or tNextTahakkukSiraNo < 1 then
                exit;
            else
       	        tToplam := tToplam + tTutar;
            end if;
            close gz_cursor;
	    end;
    end loop;

    If tToplam = 0 Then
  	     tToplam := NULL;
    end If;

return tToplam ;

end;
/
